unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, 
    Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    procedure LabelTextChanged;
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  Label1.Caption := 'Ganz ganz ganz langer Text';
  Label2.Caption := 'Text kurz';
  LabelTextChanged;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Label1.Caption := 'Text kurz';
  Label2.Caption := 'Ganz langer Text';
  LabelTextChanged;
end;

procedure TForm1.LabelTextChanged;
var
  aComponent: TComponent;
  DefComponent: TComponent;
  i: Integer;
begin
  DefComponent := nil;
  for i := 0 to ComponentCount - 1 do begin
    aComponent := Components[i];
    if Assigned(aComponent) and
       (aComponent is TLabel) and
       (not Assigned(DefComponent) or
       (TLabel(DefComponent).Canvas.TextWidth(TLabel(DefComponent).Caption) <
        TLabel(aComponent).Canvas.TextWidth(TLabel(aComponent).Caption)))
    then DefComponent := aComponent;
  end;
  if Assigned(DefComponent) then Edit1.AnchorSide[akLeft].Control := TControl(DefComponent);
//  Invalidate;
end;

end.

